pipeline {
    agent any
    tools {
        maven 'maven3.6'
        jdk 'jdk8'
    }
    
  stages {
        stage ('Build Catalyst Data Model ') {
                steps {
                    script {
                     String branchName = env.BRANCH_NAME.replaceAll("/", "%2F") 
                       try{
                             build job: "catalyst-data-model-downstream/"+ branchName, propagate: true, wait: true
                        }catch(error) {
                             echo 'could not execute on ' + branchName
                             build job: "catalyst-data-model-downstream/master", propagate: true, wait: true
                        }
                    }
                }
            }
            
        stage ('Build') {
            steps {
                sh '${M2_HOME}/bin/mvn --batch-mode -V -U -e clean verify -Dsurefire.useFile=false -Dmaven.test.failure.ignore'
            }
        }
        
             
        stage('Sonarqube Analysis') {
            environment {
                scannerHome = tool 'SonarQubeScanner'
            }
            steps {
                withSonarQubeEnv('Sonar') {
                 sh '  mvn clean install sonar:sonar'
                }
                timeout(time: 10, unit: 'MINUTES') {
                    waitForQualityGate abortPipeline: true
                }
            }
        }
    }
}
